﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using System.ComponentModel;

namespace Scrolling
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private List<MyClass> _objectList;
        public ListCollectionView ObjectListView { get; protected set; }
        public List<Option> Options { get; protected set; }

        public MainWindow()
        {
            InitializeComponent();

            Options = new List<Option>();
            Options.Add(new Option("Option 1"));
            Options.Add(new Option("Option 2"));


            _objectList = new List<MyClass>();
            for (int i = 0; i != 200; i++)
            {
                _objectList.Add(new MyClass(Options[0]));
            }

            ObjectListView = new ListCollectionView(_objectList);

            this.DataContext = this;
        }
    }

    public class Option
    {
        public String Value { get; set; }

        public Option(String o)
        {
            Value = o;
        }
    }


    public class MyClass : INotifyPropertyChanged
    {
        private Option _property = new Option("Default");

        public Option Property
        {
            get { return _property; }
            set
            {
                if (_property == value) return;
                _property = value;
                RaisePropertyChanged("Property");
            }
        }

        public MyClass(Option o)
        {
            _property = o;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            VerifyPropertyName(propertyName);
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void VerifyPropertyName(string propertyName)
        {
            if (GetType().IsVisible)
            {
                if (!string.IsNullOrEmpty(propertyName) && GetType().GetProperty(propertyName) == null)
                {
                    throw new ArgumentException("Property name does not exists on target object.", "propertyName");
                }
            }
        }

        #endregion // INotifyPropertyChanged Members
    }
}
